function [out1,out2]=leftoverpieces(puzzle,sol)
jimney=0; mun=0; rot=[]; vec=[]; hum=0; len=length(puzzle(:,1));
while jimney==0
    mun=mun+1;
    if mun==10
        break
    end
    %COMPILING SOLVED PIECES MATRIX FOR PARTIAL SOLUTION ROTATION
    cnt=0;
    if mun==1
        for h=1:len
            if isempty(sol(h).edge)==0
                for i=1:length(sol(h).edge(:,1))
                    if sol(h).edge{i,1}(1,1)~=0
                        cnt=cnt+1;
                        rot(cnt,1)=sol(h).edge{i,1}(1,1);
                        rot(cnt,2)=sol(h).edge{i,1}(1,2);
                        rot(cnt,3)=sol(h).edge{i,2}(1,1);
                        rot(cnt,4)=sol(h).edge{i,2}(1,2);
                    end
                end
            end
        end
    end
    solved=rot(:,1); solved(end+1:length(solved)*2,1)=rot(:,3); solved=sort(solved);
    %DELETING DUPLICATES
    for k=length(solved(:,1)):-1:2
        if solved(k)==solved(k-1)
            solved(k)=[];
        end
    end
    %DETERMINING SOLVED EDGES FOR STATUS MATRIX
    for i=1:len
        cnt=0;
        for j=1:length(rot(:,1))
            if  i==rot(j,1)
                cnt=cnt+1;
            end
            if i==rot(j,3)
                cnt=cnt+1;
            end
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%SEARCHING FOR ARBITRARY MATCHES%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for v=1:len    
        if isempty(sol(v).match)==0
            continue
        end
        %DETERMINING TRIAL EDGE
        for i=1:length(sol(v).edge(:,1));
            ind=i;
            %TESTING EDGE FEASIBILITY: LOOPING THROUGH SET EDGE MATCHES
            for j=1:length(puzzle(p1).edge{ind,3}(:,1))
                p1=v; e1=ind; p2=puzzle(p1).edge{e1,3}(j,2); e2=puzzle(p1).edge{e1,3}(j,3); out=0;
                %CHECK IF P2/E2 HAVE SOLUTION
                for k=1:length(rot(:,1))
                    %CHECKING PREV SOLUTION FOR P2/E2
                    if flip==1
                        if p2==rot(k,1) && e2==rot(k,2)
                            out=1; break
                        end
                    else
                        if p2==rot(k,3) && e2==rot(k,4)
                            out=1; break
                        end
                    end
                end
                if out==1
                    continue
                end
                %UPDATE SOLUTION DATABASE
                hum=hum+1; vec(hum,1:3)=0;
                vec(hum,1)=p1; vec(hum,2)=e1;
                vec(hum,3)=p2; vec(hum,4)=e2;
            end
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%  PUZZLE ASSEMBLY  %%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for i=1:len
        if isempty(sol(i).match)==0
            continue
        end
        %TRY VEC MATCHES UNTIL THERE IS A GOOD FIT
        for u=1:length(vec(:,1))  
            %DETERMINING ROTATION PIECES
            if vec(u,3)==i 
                p1=vec(u,1); p2=vec(u,3); e1=vec(u,2); e2=vec(u,4);
                piece1=puzzle(p1).piece; piece2=puzzle(p2).piece;
                curve1=puzzle(p1).edge{e1,1}; curve2=puzzle(p2).edge{e2,1};
            else
                p1=vec(u,3); p2=vec(u,1); e1=vec(u,4); e2=vec(u,2);
                piece1=puzzle(p2).piece; piece2=puzzle(p1).piece;
                curve1=puzzle(p2).edge{e2,1}; curve2=puzzle(p1).edge{e1,1};
            end
            %ACQUIRING ROTATION MATRIX AND SHIFT
            mat=puttogether(curve1,curve2,piece1,piece2);
            r=mat(1:3,1:3); t=mat(1:3,4);
            %UPDATING ROTATED PIECE      
            for j=1:length(curve2(:,1))
                curve2(j,:)=(r*(curve2(j,:))'+t)';
            end
            dist=HausdorffDist(curve1,curve2); 
            if dist<0.1
                for j=1:length(puzzle(p2).piece(:,1))
                    puzzle(p2).piece(j,:)=(r*(puzzle(p2).piece(j,:))'+t)';
                end
                if isempty(puzzle(p2).edge)==0
                    for j=1:length(puzzle(p2).edge(:,1))
                        for l=1:length(puzzle(p2).edge{j,1}(:,1))
                            puzzle(p2).edge{j,1}(l,:)=(r*(puzzle(p2).edge{j,1}(l,:))'+t)';
                        end
                    end
                end
                if isempty(puzzle(p2).edge)==0
                    for j=1:length(puzzle(p2).edge(:,1))
                        for l=1:length(puzzle(p2).edge{j,1}(:,1))
                            puzzle(p2).edge{j,1}(l,:)=(r*(puzzle(p2).edge{j,1}(l,:))'+t)';
                        end
                    end
                end
                break
            end
        end
    end  
    %COMPILING SOLUTION MATRIX BASED ON SOLVED PIECES
    for h=1:len
        if isempty(puzzle(h).edge)==0
            for i=1:length(puzzle(h).edge(:,1))
                for j=1:len
                    hit=0;
                    if h==j
                        continue
                    end
                    if isempty(puzzle(j).edge)==0
                        for k=1:length(puzzle(j).edge(:,1))
                            dist=HausdorffDist(puzzle(j).edge{k,1},puzzle(h).edge{i,1});
                            if dist<0.01
                                sol(h).edge{i,1}(1,1)=h; sol(h).edge{i,1}(1,2)=i;
                                sol(h).edge{i,2}(1,1)=j; sol(h).edge{i,2}(1,2)=k;
                                sol(j).edge{k,1}(1,1)=j; sol(j).edge{k,1}(1,2)=k;
                                sol(j).edge{k,2}(1,1)=h; sol(j).edge{k,2}(1,2)=i;
                                spot=length(sol(h).match)+1; here=length(sol(j).match)+1;
                                sol(h).match(spot)=j; sol(j).match(here)=h;
                                sol(h).match=sort(sol(h).match); sol(j).match=sort(sol(j).match);
                                hit=1;
                                break
                            end
                        end
                    end
                    if hit==1
                        break
                    end
                end
            end
        end
    end
    for h=1:len
        for k=length(sol(h).match):-1:2
            if sol(h).match(k)==sol(h).match(k-1)
                sol(h).match(k)=[];
            end
        end
    end
    jimney=1;
    for h=1:len
        if isempty(sol(h).match)==1
            jimney=0;
        end
    end   
end
out1=puzzle;
out2=sol;
end

%% PROBLEMS

% MAYBE THE LOOP SHOULD GO THROUGH ALL OF THE UNMATCHED PIECE EDGES 
% TRY ADDING AN ATTEMPTED MATCHES MATRIX
% MAYBE ADD LOOPING THROUGH IN MATCHES